﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Praktikum_1_Loesung
{
    public partial class MainWindow : Window
    {
        double x;
        DispatcherTimer timer; // benötigt using System.Windows.Threading

        public MainWindow()
        {
            InitializeComponent();

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(0.02);
            timer.Tick += Timer_Tick;
            timer.Start();
        }

        double BerechneHöhe(double x)
        {
            double s = sliderX.Value;
            return zeichenfläche.Height * (x / s - 1) * (x / s - 1) * (1.0 - x / zeichenfläche.Width);
        }

        // Wird automatisch auch ganz zu Beginn aufgerufen,
        // wenn wir Value="0.42" o.ä. für den Slider im XAML haben.
        private void sliderX_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            poly.Points.Clear();
            for (int x = 0; x < zeichenfläche.Width; x++)
            {
                Point p = new Point(x, zeichenfläche.Height - BerechneHöhe(x));
                poly.Points.Add(p);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            x = 0.0;
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            // Ableitung nähern
            const double dx = 1e-7;
            double y0 = BerechneHöhe(x - dx);
            double y1 = BerechneHöhe(x + dx);
            double ableitung = (y1 - y0) / (2.0 * dx);

            // Wagen bewegen
            double dt = timer.Interval.TotalSeconds;
            double v = Math.Sqrt(2.0 * 50.0 * (BerechneHöhe(-1e-7) - BerechneHöhe(x))); 
            x += v / Math.Sqrt(1.0 + ableitung * ableitung) * dt;

            Canvas.SetLeft(elli, x - 0.5 * elli.Width);
            Canvas.SetBottom(elli, BerechneHöhe(x) - 0.5 * elli.Height);
        }
    }
}
